Support a --quiet option in the test-suite.
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 LC_ALL=C
9 PAGER=cat
10 TZ=UTC
11 export LANG LC_ALL PAGER TZ
12 EDITOR=:
13 VISUAL=:
14 unset GIT_EDITOR
15 unset AUTHOR_DATE
16 unset AUTHOR_EMAIL
17 unset AUTHOR_NAME
18 unset COMMIT_AUTHOR_EMAIL
19 unset COMMIT_AUTHOR_NAME
20 unset EMAIL
21 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
22 unset GIT_AUTHOR_DATE
23 GIT_AUTHOR_EMAIL=author@example.com
24 GIT_AUTHOR_NAME='A U Thor'
25 unset GIT_COMMITTER_DATE
26 GIT_COMMITTER_EMAIL=committer@example.com
27 GIT_COMMITTER_NAME='C O Mitter'
28 unset GIT_DIFF_OPTS
29 unset GIT_DIR
30 unset GIT_WORK_TREE
31 unset GIT_EXTERNAL_DIFF
32 unset GIT_INDEX_FILE
33 unset GIT_OBJECT_DIRECTORY
34 unset SHA1_FILE_DIRECTORIES
35 unset SHA1_FILE_DIRECTORY
36 GIT_MERGE_VERBOSITY=5
37 export GIT_MERGE_VERBOSITY
38 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
39 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40 export EDITOR VISUAL
41
42 # Protect ourselves from common misconfiguration to export
43 # CDPATH into the environment
44 unset CDPATH
45
46 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47         1|2|true)
48                 echo "* warning: Some tests will not work if GIT_TRACE" \
49                         "is set as to trace on STDERR ! *"
50                 echo "* warning: Please set GIT_TRACE to something" \
51                         "other than 1, 2 or true ! *"
52                 ;;
53 esac
54
55 # Each test should start with something like this, after copyright notices:
56 #
57 # test_description='Description of this test...
58 # This test checks if command xyzzy does the right thing...
59 # '
60 # . ./test-lib.sh
61
62 [ "x$TERM" != "xdumb" ] &&
63         tput bold >/dev/null 2>&1 &&
64         tput setaf 1 >/dev/null 2>&1 &&
65         tput sgr0 >/dev/null 2>&1 &&
66         color=t
67
68 test "${test_description}" != "" ||
69 error "Test script did not set test_description."
70
71 while test "$#" -ne 0
72 do
73         case "$1" in
74         -d|--d|--de|--deb|--debu|--debug)
75                 debug=t; shift ;;
76         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
77                 immediate=t; shift ;;
78         -h|--h|--he|--hel|--help)
79                 echo "$test_description"
80                 exit 0 ;;
81         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
82                 verbose=t; shift ;;
83         -q|--q|--qu|--qui|--quie|--quiet)
84                 quiet=t; shift ;;
85         --no-color)
86             color=; shift ;;
87         --no-python)
88                 # noop now...
89                 shift ;;
90         *)
91                 break ;;
92         esac
93 done
94
95 if test -n "$color"; then
96         say_color () {
97                 case "$1" in
98                         error) tput bold; tput setaf 1;; # bold red
99                         skip)  tput bold; tput setaf 2;; # bold green
100                         pass)  tput setaf 2;;            # green
101                         info)  tput setaf 3;;            # brown
102                         *) test -n "$quiet" && return;;
103                 esac
104                 shift
105                 echo "* $*"
106                 tput sgr0
107         }
108 else
109         say_color() {
110                 test -z "$1" && test -n "$quiet" && return
111                 shift
112                 echo "* $*"
113         }
114 fi
115
116 error () {
117         say_color error "error: $*"
118         trap - exit
119         exit 1
120 }
121
122 say () {
123         say_color info "$*"
124 }
125
126 exec 5>&1
127 if test "$verbose" = "t"
128 then
129         exec 4>&2 3>&1
130 else
131         exec 4>/dev/null 3>/dev/null
132 fi
133
134 test_failure=0
135 test_count=0
136
137 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
138
139 test_tick () {
140         if test -z "${test_tick+set}"
141         then
142                 test_tick=1112911993
143         else
144                 test_tick=$(($test_tick + 60))
145         fi
146         GIT_COMMITTER_DATE="$test_tick -0700"
147         GIT_AUTHOR_DATE="$test_tick -0700"
148         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
149 }
150
151 # You are not expected to call test_ok_ and test_failure_ directly, use
152 # the text_expect_* functions instead.
153
154 test_ok_ () {
155         test_count=$(expr "$test_count" + 1)
156         say_color "" "  ok $test_count: $@"
157 }
158
159 test_failure_ () {
160         test_count=$(expr "$test_count" + 1)
161         test_failure=$(expr "$test_failure" + 1);
162         say_color error "FAIL $test_count: $1"
163         shift
164         echo "$@" | sed -e 's/^/        /'
165         test "$immediate" = "" || { trap - exit; exit 1; }
166 }
167
168
169 test_debug () {
170         test "$debug" = "" || eval "$1"
171 }
172
173 test_run_ () {
174         eval >&3 2>&4 "$1"
175         eval_ret="$?"
176         return 0
177 }
178
179 test_skip () {
180         this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
181         this_test="$this_test.$(expr "$test_count" + 1)"
182         to_skip=
183         for skp in $GIT_SKIP_TESTS
184         do
185                 case "$this_test" in
186                 $skp)
187                         to_skip=t
188                 esac
189         done
190         case "$to_skip" in
191         t)
192                 say_color skip >&3 "skipping test: $@"
193                 test_count=$(expr "$test_count" + 1)
194                 say_color skip "skip $test_count: $1"
195                 : true
196                 ;;
197         *)
198                 false
199                 ;;
200         esac
201 }
202
203 test_expect_failure () {
204         test "$#" = 2 ||
205         error "bug in the test script: not 2 parameters to test-expect-failure"
206         if ! test_skip "$@"
207         then
208                 say >&3 "expecting failure: $2"
209                 test_run_ "$2"
210                 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
211                 then
212                         test_ok_ "$1"
213                 else
214                         test_failure_ "$@"
215                 fi
216         fi
217         echo >&3 ""
218 }
219
220 test_expect_success () {
221         test "$#" = 2 ||
222         error "bug in the test script: not 2 parameters to test-expect-success"
223         if ! test_skip "$@"
224         then
225                 say >&3 "expecting success: $2"
226                 test_run_ "$2"
227                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
228                 then
229                         test_ok_ "$1"
230                 else
231                         test_failure_ "$@"
232                 fi
233         fi
234         echo >&3 ""
235 }
236
237 test_expect_code () {
238         test "$#" = 3 ||
239         error "bug in the test script: not 3 parameters to test-expect-code"
240         if ! test_skip "$@"
241         then
242                 say >&3 "expecting exit code $1: $3"
243                 test_run_ "$3"
244                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
245                 then
246                         test_ok_ "$2"
247                 else
248                         test_failure_ "$@"
249                 fi
250         fi
251         echo >&3 ""
252 }
253
254 # Most tests can use the created repository, but some amy need to create more.
255 # Usage: test_create_repo <directory>
256 test_create_repo () {
257         test "$#" = 1 ||
258         error "bug in the test script: not 1 parameter to test-create-repo"
259         owd=`pwd`
260         repo="$1"
261         mkdir "$repo"
262         cd "$repo" || error "Cannot setup test environment"
263         "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
264         error "cannot run git init -- have you built things yet?"
265         mv .git/hooks .git/hooks-disabled
266         cd "$owd"
267 }
268
269 test_done () {
270         trap - exit
271         case "$test_failure" in
272         0)
273                 # We could:
274                 # cd .. && rm -fr trash
275                 # but that means we forbid any tests that use their own
276                 # subdirectory from calling test_done without coming back
277                 # to where they started from.
278                 # The Makefile provided will clean this test area so
279                 # we will leave things as they are.
280
281                 say_color pass "passed all $test_count test(s)"
282                 exit 0 ;;
283
284         *)
285                 say_color error "failed $test_failure among $test_count test(s)"
286                 exit 1 ;;
287
288         esac
289 }
290
291 # Test the binaries we have just built.  The tests are kept in
292 # t/ subdirectory and are run in trash subdirectory.
293 PATH=$(pwd)/..:$PATH
294 GIT_EXEC_PATH=$(pwd)/..
295 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
296 GIT_CONFIG=.git/config
297 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
298
299 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
300 export GITPERLLIB
301 test -d ../templates/blt || {
302         error "You haven't built things yet, have you?"
303 }
304
305 if ! test -x ../test-chmtime; then
306         echo >&2 'You need to build test-chmtime:'
307         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
308         exit 1
309 fi
310
311 # Test repository
312 test=trash
313 rm -fr "$test"
314 test_create_repo $test
315 cd "$test"
316
317 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
318 for skp in $GIT_SKIP_TESTS
319 do
320         to_skip=
321         for skp in $GIT_SKIP_TESTS
322         do
323                 case "$this_test" in
324                 $skp)
325                         to_skip=t
326                 esac
327         done
328         case "$to_skip" in
329         t)
330                 say_color skip >&3 "skipping test $this_test altogether"
331                 say_color skip "skip all tests in $this_test"
332                 test_done
333         esac
334 done